
import "SDRPlugins.WardenEase2";

Turbine.Plugin.Load = function(self, sender, args)
	Turbine.Shell.WriteLine("WardenEase2 v" .. self:GetVersion() .. " created by Deusdictum and updated by " .. self:GetAuthor() .. " is now loaded!");
end

version = plugin:GetVersion(); -- gets the plugin version from the WardenEase.plugin file

-- add and remove callback functions, thanks to Pengoros
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

WEmain = WEController();

WEmainCommand = Turbine.ShellCommand();

function WEmainCommand:Execute( command, arguments )
	if ( arguments == "show" ) then
		WEmain:SetVisible( true );
	elseif ( arguments == "hide" ) then
		WEmain:SetVisible( false );
	elseif ( arguments == "toggle" ) then
		WEmain:SetVisible( not WEmain:IsVisible() );
	elseif ( arguments == "refresh" ) then
		WEmain:RefreshQuickslots();
	elseif ( WEmain:IsGambitAvailable(arguments) ~= nil ) then
		WEmain:SetGambit( WEmain:IsGambitAvailable(arguments) );
	else Turbine.Shell.WriteLine(WEmainCommand:GetHelp());
	end
end

function WEmainCommand:GetHelp()
	return "Warden Ease 2 commands:\n    we2 show: Display the main WardenEase2 quickslots\n    we2 hide: Hides the main WardenEase2 quickslots\n    we2 toggle: toggles the visibility of the main WardenEase2 quickslots\n    we2 refresh: Will refresh the quickslots (you need to do this after training gambits and certain skills)\n    we2 [GambitName]: Sets the Gambit with the name \"GambitName\"; does not have to be the entire name or match capital/lowercase letters";
end

function WEmainCommand:GetShortHelp()
	return "Shows or hides the main WardenEase2 quickslots.";
end

Turbine.Shell.AddCommand( "we2;WardenEase2", WEmainCommand );

Turbine.Plugin.Unload = function(self, sender, args)
	RemoveCallback(player, "LevelChanged", levelChangedHandler1);
	RemoveCallback(player, "LevelChanged", levelChangedHandler2);
	RemoveCallback(Turbine.Gameplay.Attributes.WardenAttributes, "GambitChanged", wardenGambitChangedHandler);
end